function error(msg) {
  $('#renderArea').hide();
  $('#GCodeErrorDiv').html(msg);
  $('#GCodeErrorDiv').show();
}

function GCodeStatus(msg)
{
  $('#renderArea').hide();
  $('#GCodeStatusDiv').html(msg);
  $('#GCodeStatusDiv').show();
}

function loadFile(path, callback /* function(contents) */) {
  $.get(path, null, callback, 'text')
    .error(function() { error() });
}

function about() {
  $('#aboutModal').modal();
}

function openDialog() {
  $('#openModal').modal();
}

var scene = null;
var object = null;

function openGCodeFromPath(path) {
  $('#openModal').modal('hide');
  if (object) {
    scene.remove(object);
  }
  loadFile(path, function(gcode) {
    object = createObjectFromGCode(gcode);
    scene.add(object);
    
    localStorage.setItem('last-loaded', path);
    localStorage.removeItem('last-imported');
    
    $('#GCodeStatusDiv').hide();
    $('#renderArea').show();
  });
}

function openGCodeFromText(gcode) {
  $('#openModal').modal('hide');
  if (object) {
    scene.remove(object);
  }
  object = createObjectFromGCode(gcode);
  scene.add(object);
  localStorage.setItem('last-imported', gcode);
  localStorage.removeItem('last-loaded');
}


function initializeGCodeViewer(url) {

  if (!Modernizr.webgl) {
    alert('Sorry, you need a WebGL capable browser to use this.\n\nGet the latest Chrome or FireFox.');
    return;
  }

  if (!Modernizr.localstorage) {
    alert("Man, your browser is ancient. I can't work with this. Please upgrade.");
    return;
  }

  GCodeStatus("Loading GCode...");

  // Show 'About' dialog for first time visits.
  /*
  if (!localStorage.getItem("not-first-visit")) {
    localStorage.setItem("not-first-visit", true);
    setTimeout(about, 500);
  }
  */

  // Drop files from desktop onto main page to import them.
  $('body').on('dragover', function(event) {
    event.stopPropagation();
    event.preventDefault();
    event.originalEvent.dataTransfer.dropEffect = 'copy'
  }).on('drop', function(event) {
    event.stopPropagation();
    event.preventDefault();
    var files = event.originalEvent.dataTransfer.files;
    if (files.length > 0) {
      var reader = new FileReader();
      reader.onload = function() {
        openGCodeFromText(reader.result);
      };
      reader.readAsText(files[0]);
    }
  });

  scene = createScene($('#renderArea'));
  
  /*
  var lastImported = localStorage.getItem('last-imported');
  var lastLoaded = localStorage.getItem('last-loaded');
  if (lastImported) {
    openGCodeFromText(lastImported);
  } else {
    openGCodeFromPath(lastLoaded || 'examples/hand_ok.gcode');
  }
  */
  
  openGCodeFromPath(url);
}

